#ifndef resconst_h
#define resconst_h


namespace resconst
{
  extern void init();

  //number of light flavours
  extern const int NF;

  //Mathematics constants
  extern const double Z2;
  extern const double Z3;
  extern const double Z4;
  extern const double Z5;
  extern const double b0;
  
  //Resummation coefficients
  extern double beta0, beta1, beta2, beta3, beta4, Kappa;
  extern double A1g, A2g, A3g, B1g, B2g, C1ggn;
  extern double A1q, A2q, A3q, A4q;
  extern double B1q, B2q, B3q;
  extern double B1qHSCHM, B2qHSCHM, B3qHSCHM;
  extern double H1q, H2q, H3q;
  extern double K1, K2, K3, K4;
  extern double C1qqn, C2qqn;
  extern double s1, s2, s3;
  extern double k1, k2, k3, k3_nfv;

  // Delta terms
  extern double C1qqdelta, Delta2qq;

  // Coefficients of D0 and D1 in P*P (as/M_PI normalization)
  extern double D0qqqq, D1qqqq;

  // Coefficients of delta(1-z) in P*P
  extern double Deltaqqqq;

  // H2qq contribution: coefficient of delta(1-z)
  extern double H2qqdelta;

  // H2qq contribution: coefficient of D0(z)
  extern double H2qqD0;
}

#endif
